diff --git a/control-notify.c b/control-notify.c
index cc706ac242..4876dd05a2 100644
--- a/control-notify.c
+++ b/control-notify.c
@@ -171,6 +171,16 @@ control_notify_client_session_changed(struct client *cc)
 	}
 }
 
+void
+control_notify_client_detached(struct client *cc) {
+	struct client	*c;
+	TAILQ_FOREACH(c, &clients, entry) {
+		if (CONTROL_SHOULD_NOTIFY_CLIENT(c)) {
+            control_write(c, "%%client-detached %s", cc->name);
+        }
+	}
+}
+
 void
 control_notify_session_renamed(struct session *s)
 {
diff --git a/notify.c b/notify.c
index f7440cadce..4b9b1eaa99 100644
--- a/notify.c
+++ b/notify.c
@@ -125,6 +125,8 @@ notify_callback(struct cmdq_item *item, void *data)
 		control_notify_window_renamed(ne->window);
 	if (strcmp(ne->name, "client-session-changed") == 0)
 		control_notify_client_session_changed(ne->client);
+	if (strcmp(ne->name, "client-detached") == 0)
+		control_notify_client_detached(ne->client);
 	if (strcmp(ne->name, "session-renamed") == 0)
 		control_notify_session_renamed(ne->session);
 	if (strcmp(ne->name, "session-created") == 0)
diff --git a/tmux.h b/tmux.h
index ca71559f47..fbc78d2f8b 100644
--- a/tmux.h
+++ b/tmux.h
@@ -2946,6 +2946,7 @@ void	control_notify_window_unlinked(struct session *, struct window *);
 void	control_notify_window_linked(struct session *, struct window *);
 void	control_notify_window_renamed(struct window *);
 void	control_notify_client_session_changed(struct client *);
+void	control_notify_client_detached(struct client *);
 void	control_notify_session_renamed(struct session *);
 void	control_notify_session_created(struct session *);
 void	control_notify_session_closed(struct session *);
